Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 828445 - sys-kernel/genkernel-4.2.6-r1 missing fuse-2.9.9-r1 patch, can't build initramfs if using glibc-2.34
Summary: sys-kernel/genkernel-4.2.6-r1 missing fuse-2.9.9-r1 patch, can't build initra...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo Genkernel Maintainers
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: glibc-2.34
  Show dependency tree
 
Reported: 2021-12-06 03:11 UTC by Luíza Utsch
Modified: 2021-12-10 01:00 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
genkernel's build log (genkernel.log,937.27 KB, text/x-log)
2021-12-06 03:13 UTC, Luíza Utsch
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Luíza Utsch 2021-12-06 03:11:41 UTC
Bug 803923 was fixed for sys-fs/fuse-2.9.9-r1, a fix was submitted and merged into upstream but a new release wasn't created and maybe won't ever be (2.9.9 is a maintenance release, fuse-3.X should be used). In the meantime, genkernel needs to include patches from https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=8a970396fca7aca2d5a761b8e7a8242f1eef14c9 or building initramfs fails:

x86_64-pc-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I../include  -D_FILE_OFFSET_BITS=64    -Os -pipe -fomit-frame-pointer -c -o mount.fuse.o mount.fuse.c
(...)
ulockmgr_server.c:127:12: error: conflicting types for 'closefrom'; have 'int(int)'
  127 | static int closefrom(int minfd)
      |            ^~~~~~~~~
In file included from ulockmgr_server.c:14:
/usr/include/unistd.h:363:13: note: previous declaration of 'closefrom' with type 'void(int)'
  363 | extern void closefrom (int __lowfd) __THROW;
      |             ^~~~~~~~~


Reproducible: Always

Steps to Reproduce:
1.Run genkernel all or genkernel initramfs
Actual Results:  
* Gentoo Linux Genkernel; Version 4.2.6
* Using genkernel configuration from '/etc/genkernel.conf' ...
* Running with options: all

* Working with Linux kernel 5.15.6-gentoo-x86_64 for x86_64
* Using kernel config file '/etc/kernels/kernel-config-5.15.6-gentoo-x86_64' ...
* 
* Note: The version above is subject to change (depends on config and status of kernel sources).

* kernel: >> Initializing ...
*         >> --no-clean is set; Skipping 'make clean' ...
*         >> --no-mrproper is set; Skipping 'make mrproper' ...
*         >> Running 'make oldconfig' ...
*         >> Compiling 5.15.6-gentoo-x86_64 bzImage ...
*         >> Compiling 5.15.6-gentoo-x86_64 modules ...
*         >> Installing 5.15.6-gentoo-x86_64 modules (and stripping) ...
*         >> Generating module dependency data ...
*         >> Saving config of successful build to '/etc/kernels/kernel-config-5.15.6-gentoo-x86_64' ...

* initramfs: >> Initializing ...
*         >> Appending devices cpio data ...
*         >> Appending base_layout cpio data ...
*         >> Appending util-linux cpio data ...
*         >> Appending eudev cpio data ...
*         >> Appending devicemanager cpio data ...
*         >> Appending auxiliary cpio data ...
*         >> Appending busybox cpio data ...
*         >> Appending modprobed cpio data ...
*         >> Appending unionfs_fuse cpio data ...
* ERROR: Command 'nice -n10 make -j5 -l4 V=1' failed!
* ERROR: create_initramfs(): append_data(): append_unionfs_fuse(): populate_binpkg(): populate_binpkg(): gkbuild(): Failed to create binpkg of fuse-2.9.9!
* Please consult '/var/log/genkernel.log' for more information and any
* errors that were reported above.
* 
* Report any genkernel bugs to bugs.gentoo.org and
* assign your bug to genkernel@gentoo.org. Please include
* as much information as you can in your bug report; attaching
* '/var/log/genkernel.log' so that your issue can be dealt with effectively.
* 
* Please do *not* report kernel compilation failures as genkernel bugs!
* 


Expected Results:  
* Gentoo Linux Genkernel; Version 4.2.6
* Using genkernel configuration from '/etc/genkernel.conf' ...
* Running with options: all

* Working with Linux kernel 5.15.6-gentoo-x86_64 for x86_64
* Using kernel config file '/etc/kernels/kernel-config-5.15.6-gentoo-x86_64' ...
* 
* Note: The version above is subject to change (depends on config and status of kernel sources).

* kernel: >> Initializing ...
*         >> --no-clean is set; Skipping 'make clean' ...
*         >> --no-mrproper is set; Skipping 'make mrproper' ...
*         >> Running 'make oldconfig' ...
*         >> Compiling 5.15.6-gentoo-x86_64 bzImage ...
*         >> Compiling 5.15.6-gentoo-x86_64 modules ...
*         >> Installing 5.15.6-gentoo-x86_64 modules (and stripping) ...
*         >> Generating module dependency data ...
*         >> Saving config of successful build to '/etc/kernels/kernel-config-5.15.6-gentoo-x86_64' ...

* initramfs: >> Initializing ...
*         >> Appending devices cpio data ...
*         >> Appending base_layout cpio data ...
*         >> Appending util-linux cpio data ...
*         >> Appending eudev cpio data ...
*         >> Appending devicemanager cpio data ...
*         >> Appending auxiliary cpio data ...
*         >> Appending busybox cpio data ...
*         >> Appending modprobed cpio data ...
*         >> Appending unionfs_fuse cpio data ...
*         >> Appending modules cpio data ...
*         >> Deduping cpio ...
*         >> Pre-generating initramfs' /etc/ld.so.cache ...
*         >> Compressing cpio data (.xz) ...

* Kernel compiled successfully!


Portage 3.0.28 (python 3.9.9-final-0, default/linux/amd64/17.1/desktop, gcc-11.2.1, glibc-2.34-r3, 5.15.1-gentoo-x86_64 x86_64)
=================================================================
System uname: Linux-5.15.1-gentoo-x86_64-x86_64-Intel-R-_Core-TM-_i7-3820_CPU_@_3.60GHz-with-glibc2.34
KiB Mem:    16326344 total,   6140640 free
KiB Swap:    2047996 total,   2047996 free
Timestamp of repository gentoo: Mon, 06 Dec 2021 01:00:01 +0000
Head commit of repository gentoo: d1d1adfe88bff7b5289e33dc2fe01b9382aa71b0
Head commit of repository steam-overlay: bcdf7b7b1ffb3058a0d924e849a5abf18f364d9c

sh bash 5.1_p12
ld GNU ld (Gentoo 2.37_p1 p1) 2.37
app-shells/bash:          5.1_p12::gentoo
dev-java/java-config:     2.3.1::gentoo
dev-lang/perl:            5.34.0-r5::gentoo
dev-lang/python:          3.8.12_p1::gentoo, 3.9.9::gentoo, 3.10.0_p1::gentoo
dev-lang/rust:            1.56.1::gentoo
dev-util/cmake:           3.22.0::gentoo
sys-apps/baselayout:      2.8::gentoo
sys-apps/openrc:          0.44.9::gentoo
sys-apps/sandbox:         2.29::gentoo
sys-devel/autoconf:       2.13-r1::gentoo, 2.71-r1::gentoo
sys-devel/automake:       1.16.5::gentoo
sys-devel/binutils:       2.37_p1-r1::gentoo
sys-devel/gcc:            11.2.1_p20211127::gentoo
sys-devel/gcc-config:     2.5-r1::gentoo
sys-devel/libtool:        2.4.6-r6::gentoo
sys-devel/make:           4.3::gentoo
sys-kernel/linux-headers: 5.15-r1::gentoo (virtual/os-headers)
sys-libs/glibc:           2.34-r3::gentoo
Repositories:

gentoo
    location: /var/db/repos/gentoo
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-verify-jobs: 1
    sync-rsync-extra-opts: 
    sync-rsync-verify-metamanifest: yes
    sync-rsync-verify-max-age: 24

gamerlay
    location: /var/lib/layman/gamerlay
    masters: gentoo
    priority: 50

steam-overlay
    location: /usr/local/portage/steam-overlay
    sync-type: git
    sync-uri: https://github.com/anyc/steam-overlay.git
    masters: gentoo
    priority: 50

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=sandybridge -O2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php8.0/ext-active/ /etc/php/apache2-php8.1/ext-active/ /etc/php/cgi-php8.0/ext-active/ /etc/php/cgi-php8.1/ext-active/ /etc/php/cli-php8.0/ext-active/ /etc/php/cli-php8.1/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-march=sandybridge -O2 -pipe"
DISTDIR="/var/cache/distfiles"
ENV_UNSET="CARGO_HOME DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN GOPATH PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-march=sandybridge -O2 -pipe"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync metadata-transfer multilib-strict network-sandbox news parallel-fetch parallel-install pid-sandbox preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-march=sandybridge -O2 -pipe"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="en_US.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j5 -l4"
PKGDIR="/var/cache/binpkgs"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 aac acl acpi alsa amd64 bash-completion bluetooth branding bzip2 cairo cdda cddb cdr cjk cli crypt cscope cups dbus dri dts dvd dvdr elogind emboss encode exif ffmpeg flac fontconfig fortran gdbm gif gles1 gnutls gpm gtk gui hal iconv icu ipv6 java jpeg lcms libglvnd libnotify libtirpc linguas_en linguas_en_GB lm-sensors log4j lua mad mariadb midi mng mp3 mp4 mpeg multilib ncurses nls nptl nsplugin ogg opengl openmp pam pango pcre pdf png policykit ppds pt_BR pulseaudio python qt5 readline scanner sdl seccomp spell split-usr sqlite ssl startup-notification steamruntime svg syslog systray tcl threads tiff timidity tk truetype udev udisks unicode upower usb vim-syntax vorbis webui wifi wxwidgets x264 xattr xcb xinerama xml xv xvid zlib" ABI_X86="64 32" ADA_TARGET="gnat_2020" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="mmx mmxext sse sse2 aes avx pclmul popcnt sse3 sse4_1 sse4_2 ssse3" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="efi-64 pc" INPUT_DEVICES="evdev" KERNEL="linux" L10N="en_US pt_BR" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LUA_SINGLE_TARGET="lua5-1" LUA_TARGETS="lua5-1" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-3 php7-4" POSTGRES_TARGETS="postgres12 postgres13" PYTHON_SINGLE_TARGET="python3_9" PYTHON_TARGETS="python3_9" RUBY_TARGETS="ruby26" USERLAND="GNU" VIDEO_CARDS="fbdev dummy vesa vga radeonsi amdgpu" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq proto steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, LINGUAS, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, RUSTFLAGS
Comment 1 Luíza Utsch 2021-12-06 03:13:27 UTC
Created attachment 757540 [details]
genkernel's build log
Comment 2 Andreas K. Hüttel archtester gentoo-dev 2021-12-06 23:00:15 UTC
Sigh. Things tend to take longer when the wheel needs to be reinvented.
Comment 3 Sam James archtester gentoo-dev Security 2021-12-06 23:04:12 UTC
(In reply to Andreas K. Hüttel from comment #2)
> Sigh. Things tend to take longer when the wheel needs to be reinvented.

I'm not sure why genkernel is special here. Seems to regularly use (in its stable version) versions which are not yet marked stable in Gentoo and doesn't include all patches either...
Comment 4 Larry the Git Cow gentoo-dev 2021-12-10 01:00:09 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/proj/genkernel.git/commit/?id=1b1da7527b0307cb70118caf5dfe2da778671588

commit 1b1da7527b0307cb70118caf5dfe2da778671588
Author:     Thomas Deutschmann <whissi@gentoo.org>
AuthorDate: 2021-12-10 00:56:20 +0000
Commit:     Thomas Deutschmann <whissi@gentoo.org>
CommitDate: 2021-12-10 00:56:20 +0000

    fuse: Add patch to allow building against glibc-2.34
    
    Bug: https://bugs.gentoo.org/828445
    Signed-off-by: Thomas Deutschmann <whissi@gentoo.org>

 patches/fuse/2.9.9/fuse-2.9.9-glibc-2.34.patch | 60 ++++++++++++++++++++++++++
 1 file changed, 60 insertions(+)
Comment 5 Larry the Git Cow gentoo-dev 2021-12-10 01:00:24 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=1b9bf0269cd8276bb65546b738cd672323a4483a

commit 1b9bf0269cd8276bb65546b738cd672323a4483a
Author:     Thomas Deutschmann <whissi@gentoo.org>
AuthorDate: 2021-12-10 00:59:22 +0000
Commit:     Thomas Deutschmann <whissi@gentoo.org>
CommitDate: 2021-12-10 01:00:19 +0000

    sys-kernel/genkernel: allow building fuse against glibc-2.34
    
    Closes: https://bugs.gentoo.org/828445
    Package-Manager: Portage-3.0.28, Repoman-3.0.3
    Signed-off-by: Thomas Deutschmann <whissi@gentoo.org>

 .../files/genkernel-4.2.6-fuse-glibc-2.34.patch    | 77 ++++++++++++++++++++++
 ...l-4.2.6-r1.ebuild => genkernel-4.2.6-r2.ebuild} |  5 +-
 2 files changed, 81 insertions(+), 1 deletion(-)